//
//  InterstitialTagAd.m
//  PokktDemoApp
//
//  Created by Suraj Singh on 18/07/18.
//  Copyright © 2018 Suraj Singh. All rights reserved.
//

#import "InterstitialTagAd.h"
#import "UIButton+CircularButton.h"
#import <PokktSDK/PokktAdCampaignProtocol.h>
#import <PokktSDK/PokktAdViewController.h>
#import <PokktSDK/PokktAdCampaignFactory.h>
#import <PokktSDK/PokktBannerAdView.h>


@interface InterstitialTagAd ()
@property(strong,nonatomic) PokktAdConfig *adconfig;
@property(strong, nonatomic) UIView *placeHolderV;
@property(strong, nonatomic) NSString *inputFormat;
@end

@implementation InterstitialTagAd

- (void)viewDidLoad {
    [super viewDidLoad];
    
    
    // Do any additional setup after loading the view.
     logoImg.transform = CGAffineTransformMakeRotation(-M_1_PI);
    
    [videoBtn setSelected:YES];
    [videoBtn makeCircularButton:@"Video"];
    
    [interstitialBtn makeCircularButton:@"Interstitial"];
    
    [bannerBtn makeCircularButton:@"Banner"];
    
    [vastBtn setSelected:YES];
    [vastBtn makeCircularButton:@"Vast"];
    
    [jsonBtn makeCircularButton:@"Json"];
    
    [vastjsonBtn setSelected:YES];
    [vastjsonBtn makeCircularButton:@"Vast/Json"];
    
    [urlBtn setSelected:NO];
    [urlBtn makeCircularButton:@"URL"];
    
    [htmlBtn setSelected:NO];
    [htmlBtn makeCircularButton:@"HTML"];
    
    
    _adconfig = [[PokktAdConfig alloc] init];
    _adconfig.adFormat = VIDEO;
    
    networkModel = [[PokktNetworkModel alloc] init];
    networkModel.name = @"POKKT_VIDEO";
    networkModel.networkID = @"31";
    networkModel.intgrationType = @"S2S";
    networkModel.className = @"S2SNetwork";
    networkModel.adFormat = 0;
    networkModel.type = 3;
    networkModel.responseFormat = 1;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


-(IBAction)adFormatAction:(id)sender
{
    UIButton *btn = (UIButton *)sender;
    [videoBtn setSelected:NO];
    [interstitialBtn setSelected:NO];
    [bannerBtn setSelected:NO];
    
    if (btn.tag == 101)
    {
        [videoBtn setSelected:YES];
        networkModel.name = @"POKKT_VIDEO";
        networkModel.networkID = @"31";
        networkModel.intgrationType = @"S2S";
        networkModel.className = @"S2SNetwork";
        networkModel.adFormat = 0;
        networkModel.type = 3;
        _adconfig.adFormat = VIDEO;
        
    }
    else if (btn.tag == 102)
    {
        [interstitialBtn setSelected:YES];
        networkModel.name = @"POKKT_INTERSTITIAL";
        networkModel.networkID = @"33";
        networkModel.intgrationType = @"S2S";
        networkModel.className = @"S2SNetwork";
        networkModel.adFormat = 3;
        networkModel.type = 3;
        _adconfig.adFormat = INTERSTITIAL;
    }
    else if (btn.tag == 103)
    {
        [bannerBtn setSelected:YES];
        networkModel.name = @"POKKT_BANNER";
        networkModel.networkID = @"32";
        networkModel.intgrationType = @"S2S";
        networkModel.className = @"S2SNetwork";
        networkModel.adFormat = 1;
        networkModel.type = 3;
        _adconfig.adFormat = BANNER;
    }
    
    [videoBtn onChangeSelectionState];
    [interstitialBtn onChangeSelectionState];
    [bannerBtn onChangeSelectionState];
}

-(IBAction)responseFormatAction:(id)sender
{
    UIButton *btn = (UIButton *)sender;
    [vastBtn setSelected:NO];
    [jsonBtn setSelected:NO];
    [bannerBtn setSelected:NO];
    
    if (btn.tag == 201)
    {
        [vastBtn setSelected:YES];
        networkModel.responseFormat = 0;
    }
    else if (btn.tag == 202)
    {
        [jsonBtn setSelected:YES];
        networkModel.responseFormat = 1;
    }
    
    
    [jsonBtn onChangeSelectionState];
    [vastBtn onChangeSelectionState];
}

-(IBAction)inputFormatAction:(id)sender
{
    UIButton *btn = (UIButton *)sender;
    
    if (btn.tag == 301)
    {
        [vastjsonBtn setSelected:YES];
        self.inputFormat = @"VAST";
    }
    else if (btn.tag == 302)
    {
       [urlBtn setSelected:YES];
        self.inputFormat = @"URL";
    }
    else if (btn.tag == 303)
    {
      [htmlBtn setSelected:YES];
        self.inputFormat = @"HTML";
    }
    
    [vastjsonBtn onChangeSelectionState];
    [urlBtn onChangeSelectionState];
    [htmlBtn onChangeSelectionState];
   
}

-(IBAction)requestAdAction:(id)sender
{
    if ([vastTV.text hasPrefix:@"<VAST"] || [vastTV.text hasPrefix:@"{"] || [vastTV.text hasPrefix:@"["]) {
        [self showAd:vastTV.text];
    }
    else if ([vastTV.text hasPrefix:@"http"])
    {
        [self getDataFromRequest:vastTV.text];
    }
    
    
}

-(void)showAd:(NSString *)dataString
{
    _adconfig.isRewarded = YES;
    id<PokktAdCampaignProtocol> campaign;
    if (networkModel.responseFormat == 0) {
        campaign = [PokktAdCampaignFactory createAdCampaignWithResponseString:dataString adNetworkModel:networkModel];
    }
    else
    {
        campaign = [PokktAdCampaignFactory createAdCampaignWithResponseString:dataString adNetworkModel:networkModel];
    }
    //    PokktJsonAdCampaign *vastCampaign = [PokktAdCampaignFactory createAdCampaignWithResponseString:dataString adNetworkModel:networkModel];
    [campaign setCacheType:SHOW_AD];
    PokktAdPlayerViewConfig *viewConfig = [[PokktAdPlayerViewConfig alloc] init];
    viewConfig.shouldAllowMute = YES;
    viewConfig.shouldAllowSkip = YES;
    [campaign updateAdCampaignWithAdConfig:viewConfig];
    
    if (_adconfig.adFormat == BANNER)
    {
        [destroyBtn setHidden:NO];
        PokktBannerAdView *adView = [[PokktBannerAdView alloc] init];
        adView.bannerVC = self;
        self.placeHolderV = [[UIView alloc] initWithFrame:CGRectMake(0, 0, 320, 50)];
        [self.placeHolderV setBackgroundColor:[UIColor redColor]];
        [self.view addSubview:self.placeHolderV];
        adView.bannerViewAd = self.placeHolderV;
        
        [adView loadWebView:campaign.getInterstitialAdCreative BaseUrl:[NSURL URLWithString:[campaign getBaseUrl]] isCoppaEnabled:YES isMraidContent:YES];
    }
    else if (_adconfig.adFormat == INTERSTITIAL && [self.inputFormat isEqualToString:@"HTML"])
    {
        [PokktInterstitial playWithTag:vastTV.text onViewController:self];
    }
    else
    {
        PokktAdViewController *adController = [[PokktAdViewController alloc] init];
        adController.videoPlacementType = campaign.getVideoPlacementType;
        [self presentViewController:adController animated:NO completion:^{
            dispatch_async(dispatch_get_main_queue(), ^{
                // do work here
                [adController showAd:campaign withAdConfig:self.adconfig networkModel:networkModel];
            });
            
            
        }];
        
    }
  
}


-(void)getDataFromRequest:(NSString *)url
{
    NSMutableURLRequest *urlRequest = [[NSMutableURLRequest alloc] initWithURL:[NSURL URLWithString:url]];
    
    //create the Method "GET"
    [urlRequest setHTTPMethod:@"GET"];
    
    NSURLSession *session = [NSURLSession sharedSession];
    
    NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:urlRequest completionHandler:^(NSData *data, NSURLResponse *response, NSError *error)
                                      {
                                          NSHTTPURLResponse *httpResponse = (NSHTTPURLResponse *)response;
                                          if(httpResponse.statusCode == 200)
                                          {
                                              NSError *parseError = nil;
                                              NSString *dataString = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
                                              
                                              
                                              dispatch_async(dispatch_get_main_queue(), ^{
                                                  // do work here
                                                  [self showAd:dataString];
                                              });
                                              
                                          }
                                          
                                      }];
    [dataTask resume];
}



- (BOOL)textView:(UITextView *)textView
shouldChangeTextInRange:(NSRange)range
 replacementText:(NSString *)text
{
    if ([text isEqualToString:@"\n"])
    {
        [textView resignFirstResponder];
    }
    return YES;
}

@end
