//
//  PokktWebViewVC.m
//  PokktDemoApp
//
//  Created by Suraj Singh on 16/05/18.
//  Copyright © 2018 Suraj Singh. All rights reserved.
//

#import "PokktWebViewVC.h"

@interface PokktWebViewVC ()

@end

@implementation PokktWebViewVC

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    [self configurePokktSDK];
    
    NSURL *url = [NSURL URLWithString:@"https://s3-ap-southeast-1.amazonaws.com/sdkplugin/test/test.html"];
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    webView.delegate = self;
    [webView loadRequest:request];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)configurePokktSDK
{
    NSUserDefaults *settings = [NSUserDefaults standardUserDefaults];
    
    NSString *appId = [settings objectForKey:@"appId"];
    NSString *securityKey = [settings objectForKey:@"secKey"];
    
    /**
     * In [PokktAds setPokktConfig: securityKey:]
     * Replace "AppID" and "SecurityKey"  with the one assigned to you by Pokkt.
     *
     */
    
    [PokktAds setPokktConfigWithAppId:appId securityKey:securityKey];
    
    // optional, set it to true if you want to enable logs for PokktSDK
    
    [PokktDebugger setDebug:YES];
    
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
{
    if ([PokktOutStreamAds checkAndHandleRequest:request forScreenName:@"default"])
    {
        return NO;
    }
    
    return YES;
}


- (void)webViewDidFinishLoad:(UIWebView *)webView
{
    [PokktOutStreamAds initAgent:@"default"];
}


-(void)viewDidDisappear:(BOOL)animated
{
    [PokktOutStreamAds disappearWebViewOutStreamAd:@"default" inContainer:webView];
}

-(void)viewDidAppear:(BOOL)animated
{
    [PokktOutStreamAds loadOutstreamAd:@"default" inWebView:webView withDelegate: self];
}

- (void)outStreamAdReady:(NSString *)screenName
{
    NSString *msg = [NSString stringWithFormat:@"OutStream ad Ready for %@",screenName];
   [PokktDebugger showToast:msg viewController:self];
}

- (void)outStreamAdDisplayed: (NSString *)screenName
{
    NSString *msg = [NSString stringWithFormat:@"OutStream ad displayed for %@",screenName];
    [PokktDebugger showToast:msg viewController:self];
}

- (void)outStreamAdClicked:(NSString *)screenName
{
    NSString *msg = [NSString stringWithFormat:@"OutStream ad Clicked for %@",screenName];
    [PokktDebugger showToast:msg viewController:self];
}

- (void)outStreamAdCompleted: (NSString *)screenName
{
    NSString *msg = [NSString stringWithFormat:@"OutStream ad complete for %@",screenName];
    [PokktDebugger showToast:msg viewController:self];
}

- (void)outStreamAdFailedToShow: (NSString *)screenName errorMessage: (NSString *)errorMessage
{
    NSString *msg = [NSString stringWithFormat:@"OutStream ad falied to show for %@",screenName];
   [PokktDebugger showToast:msg viewController:self];
}

@end
