//
//  PokktBannerVC.m
//  PokktDemoApp
//
//  Created by Suraj Singh on 16/05/18.
//  Copyright © 2018 Suraj Singh. All rights reserved.
//

#import "PokktBannerVC.h"
#import "PokktUtility.h"

@interface PokktBannerVC ()

@end

@implementation PokktBannerVC

- (void)viewDidLoad {
    [super viewDidLoad];

    
    logoImgV.transform = CGAffineTransformMakeRotation(-M_1_PI);
    // Do any additional setup after loading the view.
    
    [self configurePokktSDK];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void)configurePokktSDK
{
    NSUserDefaults *settings = [NSUserDefaults standardUserDefaults];
    
    NSString *appId = [settings objectForKey:@"appId"];
    NSString *securityKey = [settings objectForKey:@"secKey"];
    
    /**
     * In [PokktAds setPokktConfig: securityKey:]
     * Replace "AppID" and "SecurityKey"  with the one assigned to you by Pokkt.
     *
     */
    
    [PokktAds setPokktConfigWithAppId:appId securityKey:securityKey];
    
    // optional, set it to true if you want to enable logs for PokktSDK
    
    [PokktDebugger setDebug:YES];
    
    // OPTIONAL but we SUGGEST you to implement delegates as it will help you to determine the status of your request
    
    [PokktBanner setPokktBannerDelegate:self];
}

#pragma mark Banner ad methods

-(IBAction)loadBannerAdTop:(id)sender
{
    self.banner_top = [PokktBanner initWithBannerAdSize:CGRectMake(0, 100, [UIScreen mainScreen].bounds.size.width, 50)];
    [self.banner_top setTag:1221];
    [self.banner_top setBackgroundColor:[UIColor lightGrayColor]];
    [self.view addSubview:self.banner_top];
    
    [PokktUtility addSpinnerOnButton:loadBanner_top];
    [PokktBanner loadBanner:self.banner_top withScreenName:screenTF.text rootViewContorller:self];
}

-(IBAction)destroyBannerAd_Top:(id)sender
{
    [PokktBanner destroyBanner:self.banner_top];
}

-(IBAction)loadBannerAdBottom:(id)sender
{
    self.banner_bottom = [PokktBanner initWithBannerAdSize:CGRectMake(0, [UIScreen mainScreen].bounds.size.height - 150, [UIScreen mainScreen].bounds.size.width, 50)];
    [self.banner_bottom setTag:1223];
    
    [self.banner_bottom setBackgroundColor:[UIColor lightGrayColor]];
    [self.view addSubview:self.banner_bottom];
    
    [PokktUtility addSpinnerOnButton:loadBanner_bottom];
    [PokktBanner loadBanner:self.banner_bottom withScreenName:screenTF.text rootViewContorller:self];
}

-(IBAction)destroyBannerAdBotton:(id)sender
{
    [PokktBanner destroyBanner:self.banner_bottom];
}


#pragma mark Pokkt Banner Ads Delegates

- (void)bannerLoaded:(NSString *)screenName
{
    NSString *msg = [NSString stringWithFormat:@"Banner loaded successfully for %@",screenName];
    [PokktDebugger showToast:msg viewController:self];
    [PokktUtility stopSpinner:loadBanner_top];
    [PokktUtility stopSpinner:loadBanner_bottom];
    
}

- (void)bannerClicked:(NSString *)screenName
{
    NSString *msg = [NSString stringWithFormat:@"Banner Clicked for %@",screenName];
    [PokktDebugger showToast:msg viewController:self];
}

- (void)bannerLoadFailed:(NSString *)screenName errorMessage:(NSString *)errorMessage
{
    NSString *msg = [NSString stringWithFormat:@"Banner loaded failed for screen  %@ with error is %@",screenName,errorMessage];
    [PokktDebugger showToast:msg viewController:self];
    [PokktUtility stopSpinner:loadBanner_top];
    [PokktUtility stopSpinner:loadBanner_bottom];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    return YES;
}

@end
